﻿namespace DictionaryExamples
{
    class Program
    {
        public static void Main(string[] args)
        {
            Dictionary<string, int> nameAgeDictionary = new Dictionary<string, int>();
            
            // Good way of adding.
            nameAgeDictionary.Add("Gosho", 15);
            
            // Bad way of adding.
            // Use this only when CHANGING a value.
            nameAgeDictionary["Pesho"] = 25;

            bool exists = nameAgeDictionary.ContainsKey("Gosho");
            Console.WriteLine(exists);

            bool doesNotExist = nameAgeDictionary.ContainsKey("Ivan");
            Console.WriteLine(doesNotExist);

            bool slowOperation = nameAgeDictionary.ContainsValue(25);

            // Keys Only
            foreach (var key in nameAgeDictionary.Keys)
            {
                Console.WriteLine(key);
            }

            // Values Only
            foreach (var val in nameAgeDictionary.Values)
            {
                Console.WriteLine(val);
            }

            // Both at the same time
            foreach (var kvp in nameAgeDictionary)
            {
                string key = kvp.Key;
                int value = kvp.Value;
                Console.WriteLine($"{key} - {value}");
            }

            nameAgeDictionary.Remove("Gosho");

            Console.WriteLine(nameAgeDictionary["Pesho"]);

            bool goshoAdded = nameAgeDictionary.TryAdd("Gosho", 15);
            bool peshoAdded = nameAgeDictionary.TryAdd("Pesho", 50);
            Console.WriteLine($"Gosho Added: {goshoAdded}");
            Console.WriteLine($"Pesho Added: {peshoAdded}");

            int ivanVal = 0;
            bool test = nameAgeDictionary.TryGetValue("Ivan", out ivanVal);
            Console.WriteLine(test);

            if (nameAgeDictionary.ContainsKey("Ivan"))
            {
                var val = nameAgeDictionary["Ivan"];
                // We have the value.
            }
            else
            {
                // We don't have the value.
            }

            Console.ReadLine();
        }
    }
}